<?php
declare(strict_types=1);

use Migrations\AbstractMigration;

/**
 * Class UniqueIndexForIsUnique
 *
 * Created via:
 * oitc migrations create UniqueIndexForIsUnique
 *
 * Run migration:
 * oitc migrations migrate
 *
 */
class UniqueIndexForIsUnique extends AbstractMigration {
    /**
     * Change Method.
     *
     * More information on this method is available here:
     * https://book.cakephp.org/phinx/0/en/migrations.html#the-change-method
     * @return void
     */
    public function change(): void {
        if ($this->hasTable('users')) {
            $this->table('users')
                ->addIndex(
                    [
                        'username',
                    ],
                    ['unique' => true]
                )
                ->update();
        }
    }
}
