<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace MapModule\Lib;


use itnovum\openITCOCKPIT\Core\Menu\MenuCategory;
use itnovum\openITCOCKPIT\Core\Menu\MenuHeadline;
use itnovum\openITCOCKPIT\Core\Menu\MenuInterface;
use itnovum\openITCOCKPIT\Core\Menu\MenuLink;

class Menu implements MenuInterface {

    /**
     * @return array
     */
    public function getHeadlines() {
        $Overview = new MenuHeadline(\itnovum\openITCOCKPIT\Core\Menu\Menu::MENU_OVERVIEW);
        $Overview
            ->addCategory((new MenuCategory(
                'maps_category',
                __('Maps')
            ))
                ->addLink(new MenuLink(
                    __('Maps'),
                    'MapsIndex',
                    'maps',
                    'index',
                    'MapModule',
                    'fa fa-map-marker',
                    [],
                    3
                ))
                ->addLink(new MenuLink(
                    __('Rotations'),
                    'RotationsIndex',
                    'rotations',
                    'index',
                    'MapModule',
                    'fa fa-retweet',
                    [],
                    4
                ))
            );

        return [$Overview];
    }

}
