<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace App\Lib;


use Cake\ORM\Locator\TableLocator;
use Cake\ORM\Table;

class PluginManagerTableLocator extends TableLocator {

    /**
     * @param string $alias
     * @param array $options
     * @return Table
     */
    public function get($alias, array $options = []): Table {
        $table = parent::get($alias, $options);

        //Associated Plugins with Core models
        if (is_object($table) && method_exists($table, 'initializePluginTables')) {
            $table->initializePluginTables();
        }
        return $table;
    }

    /**
     * @param string $alias
     */
    public function destroy($alias) {
        if (isset($this->_instances[$alias])) {
            unset($this->_instances[$alias]);
        }
    }
}
