<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

declare(strict_types=1);

namespace App\Model\Entity;

use Cake\ORM\Entity;

/**
 * PushAgent Entity
 *
 * @property int $id
 * @property string $uuid
 * @property string|null $host_uuid
 * @property string $password
 * @property string|null $hostname
 * @property string|null $ipaddress
 * @property string|null $remote_address
 * @property string|null $http_x_forwarded_for
 * @property string $checkresults
 * @property \Cake\I18n\FrozenTime $last_update
 * @property \Cake\I18n\FrozenTime $created
 * @property \Cake\I18n\FrozenTime $modified
 *
 */
class PushAgent extends Entity {
    /**
     * Fields that can be mass assigned using newEntity() or patchEntity().
     *
     * Note that when '*' is set to true, this allows all unspecified fields to
     * be mass assigned. For security purposes, it is advised to set '*' to false
     * (or remove it), and explicitly make individual fields accessible as needed.
     *
     * @var array
     */
    protected $_accessible = [
        'uuid'                 => true,
        'host_uuid'            => true,
        'password'             => true,
        'hostname'             => true,
        'ipaddress'            => true,
        'remote_address'       => true,
        'http_x_forwarded_for' => true,
        'checkresults'         => true,
        'last_update'          => true,
        'created'              => true,
        'modified'             => true,
    ];

    /**
     * Fields that are excluded from JSON versions of the entity.
     *
     * @var array
     */
    protected $_hidden = [
        'password',
    ];
}
