<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace App\Model\Entity;

use Cake\ORM\Entity;
use itnovum\openITCOCKPIT\Core\Views\UserTime;

/**
 * Servicecheck Entity
 *
 * @property string $hostname
 * @property string $service_description
 * @property bool $state
 * @property bool $is_hardstate
 * @property int $start_time
 * @property int $end_time
 * @property string $output
 * @property int $timeout
 * @property bool $early_timeout
 * @property float $latency
 * @property float $execution_time
 * @property string $perfdata
 * @property string $command
 * @property int $current_check_attempt
 * @property int $max_check_attempts
 * @property string $long_output
 */
class Servicecheck extends Entity {

    /**
     * @var UserTime|null
     */
    private $UserTime = null;

    /**
     * @param UserTime $UserTime
     */
    public function setUserTime(UserTime $UserTime) {
        $this->UserTime = $UserTime;
    }

    /**
     * @return array
     */
    public function jsonSerialize(): array {
        if ($this->UserTime === null) {
            return parent::jsonSerialize();
        }

        $data = parent::jsonSerialize();
        $fields = [
            'start_time',
            'end_time'
        ];

        foreach ($fields as $field) {
            if (isset($data[$field])) {
                $data[$field] = $this->UserTime->format($data[$field]);
            }
        }

        return $data;
    }

}
