<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

use App\View\Helper\ButtonGroupHelper;


$hostsButtonHelper = new ButtonGroupHelper('Display of storage notifications');

if ($this->Acl->hasPermission('index', 'Hosts', '')) {
    $hostsButtonHelper->addIconButtonWithSRef('fa fa-hdd-o', __('host alerts'), "HostsIndex()");
    $hostsButtonHelper->addButtonWithTooltipAndSRef('{{ hoststatusCount[1] }}', 'btn-danger', __('critical messages'), "HostsIndex({statename: 'down'})");
    $hostsButtonHelper->addButtonWithTooltipAndSRef('{{ hoststatusCount[2] }}', 'btn-secondary', __('warning messages'), "HostsIndex({statename: 'unreachable'})");
} else {
    $hostsButtonHelper->addIconButton('fa fa-hdd-o', __('host alerts'));
    $hostsButtonHelper->addButtonWithTooltip('{{ hoststatusCount[1] }}', 'btn-danger', __('critical messages'));
    $hostsButtonHelper->addButtonWithTooltip('{{ hoststatusCount[2] }}', 'btn-secondary', __('warning messages'));
}

$hostsHtml = $hostsButtonHelper->getHtml();
echo $hostsHtml;

$servicesBtnHelper = new ButtonGroupHelper('Display of service notifications');

if ($this->Acl->hasPermission('index', 'Services', '')) {
    $servicesBtnHelper->addIconButtonWithSRef('fas fa-cog', __('service alerts'), "ServicesIndex()");
    $servicesBtnHelper->addButtonWithTooltipAndSRef('{{ servicestatusCount[2] }}', 'btn-danger', __('messages with filter set to criticals only'), "ServicesIndex({statename: 'critical'})");
    $servicesBtnHelper->addButtonWithTooltipAndSRef('{{ servicestatusCount[1] }}', 'btn-warning', __('messages with filter set to warnings only'), "ServicesIndex({statename: 'warning'})");
    $servicesBtnHelper->addButtonWithTooltipAndSRef('{{ servicestatusCount[3] }}', 'btn-secondary', __('messages with filter set to unknowns only'), "ServicesIndex({statename: 'unknown'})");
} else {
    $servicesBtnHelper->addIconButton('fas fa-cog', __('service alerts'));
    $servicesBtnHelper->addButtonWithTooltip('{{ servicestatusCount[2] }}', 'btn-danger', __('messages with filter set to criticals only'));
    $servicesBtnHelper->addButtonWithTooltip('{{ servicestatusCount[1] }}', 'btn-warning', __('messages with filter set to warnings only'));
    $servicesBtnHelper->addButtonWithTooltip('{{ servicestatusCount[3] }}', 'btn-secondary', __('messages with filter set to unknown only'));
}

$servicesHtml = $servicesBtnHelper->getHtml();
echo $servicesHtml;
