<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

use App\View\AppView;

/**
 * @var AppView $this
 */

$SystemConfig = new \App\Lib\SystemConfig();
?>

<aside id="pageSidebar" class="page-sidebar">
    <div class="page-logo pointer" ui-sref="DashboardsIndex">
        <img src="<?= h($SystemConfig->getSidebarLogoPath()); ?>" alt="logo" aria-roledescription="logo"
             style="height: 28px;">
        <span class="page-logo-text mr-1">{{systemname}}</span>
        <span class="position-absolute text-white opacity-50 small pos-top pos-right mr-2 mt-n2"></span>
    </div>
    <!-- BEGIN PRIMARY NAVIGATION -->
    <nav id="js-primary-nav" class="primary-nav" role="navigation">
        <div class="nav-filter">
            <div class="position-relative">
                <input type="text" id="nav_filter_input"
                       placeholder="<?= __('Type to search'); ?>"
                       class="form-control"
                       tabindex="0" ng-keydown="navigate($event)">
                <a class="btn-primary btn-search-close js-waves-off" ng-click="clearAndCloseMenu()">
                    <i class="fa fa-chevron-up color-white"></i>
                </a>
            </div>
        </div>
        <div class="info-card">
            <img class="profile-image rounded-circle" alt="me" src="{{userImage}}">
            <div class="info-card-text">
                <a class="d-flex align-items-center text-white" ui-sref="ProfileEdit">
                    <span class="text-truncate text-truncate-sm d-inline-block">
                        {{userFullName}}
                    </span>
                </a>
            </div>
            <img src="/img/menu/denis-degioanni-9wH624ALFQA-unsplash.png" class="cover" alt="cover">
            <a href="javascript:void(0);" class="pull-trigger-btn" data-action="toggle"
               data-class="list-filter-active" data-target=".page-sidebar" data-focus="nav_filter_input">
                <i class="fa fa-angle-down"></i>
            </a>
        </div>

        <ul menu
            id="js-nav-menu"
            class="nav-menu"
            phpplugin="<?= $this->getRequest()->getParam('plugin', '') ?>"
            phpcontroller="<?= $this->getRequest()->getParam('controller', '') ?>"
            phpaction="<?= $this->getRequest()->getParam('action', '') ?>">>
        </ul>
        <div class="filter-message js-filter-message bg-success-600"></div>
    </nav>
    <!-- END PRIMARY NAVIGATION -->
    <!-- NAV FOOTER -->
    <div class="nav-footer shadow-top">
        <a href="javascript:void(0);" data-action="toggle" data-class="nav-function-minify"
           ng-click="setMenuMinify(false)"
           class="hidden-md-down">
            <i class="ni ni-chevron-right"></i>
            <i class="ni ni-chevron-right"></i>
        </a>
    </div> <!-- END NAV FOOTER -->
</aside>
