<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>

<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'services')): ?>
            <a ui-sref="ServicesIndex">
                <i class="fas fa-cogs"></i> <?php echo __('Services'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-cogs"></i> <?php echo __('Services'); ?>
        <?php endif; ?>
    </li>

    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('browser', 'services')): ?>
            <a ui-sref="ServicesBrowser({hostuuid: servicestatus.hostname ,serviceuuid: servicestatus.service_description})">
                <i class="fa fa-stethoscope"></i> <?php echo __('Details'); ?>
            </a>
        <?php else: ?>
            <i class="fa fa-stethoscope"></i> <?php echo __('Details'); ?>
        <?php endif; ?>
    </li>

    <li class="breadcrumb-item">
        <i class="fa fa-power-off"></i> <?php echo __('Downtime history'); ?>
    </li>
</ol>

<servicemenu servicestatus="servicestatus" showbackbutton="true" ng-if="servicestatus"></servicemenu>

<div ng-init="flashMshStr='<?php echo __('Command sent successfully. Refresh in 5 seconds'); ?>'"></div>

<mass-delete-service-downtimes delete-url="/externalcommands/cancel_downtime"
                               callback="showFlashMsg"></mass-delete-service-downtimes>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Service downtimes'); ?>
                    <span class="fw-300"><i><?php echo __('overview'); ?></i></span>
                </h2>
                <div class="panel-toolbar">
                    <!-- header buttons start -->
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <button class="btn btn-xs btn-primary shadow-0 " ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                    <!-- header buttons end -->
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">

                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span
                                                        class="input-group-text filter-text"><?php echo __('From'); ?></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   style="padding:0.5rem 0.875rem;"
                                                   placeholder="<?php echo __('From date'); ?>"
                                                   ng-model="filter.from"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>

                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span
                                                        class="input-group-text filter-text"><?php echo __('To'); ?></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   style="padding:0.5rem 0.875rem;"
                                                   placeholder="<?php echo __('To date'); ?>"
                                                   ng-model="filter.to"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-user"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by user'); ?>"
                                                   ng-model="filter.DowntimeHosts.author_name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by comment'); ?>"
                                                   ng-model="filter.DowntimeHosts.comment_data"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('Options'); ?></h5>
                                        <div class="form-group">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterIsRunning"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.isRunning"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="statusFilterIsRunning"><?php echo __('Is running'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterWasNotCancelled"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.DowntimeHosts.was_not_cancelled"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="statusFilterWasNotCancelled"><?php echo __('Was not cancelled'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterWasCancelled"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.DowntimeHosts.was_cancelled"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="statusFilterWasCancelled"><?php echo __('Was cancelled'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterHideExpired"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.hideExpired"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="statusFilterHideExpired"><?php echo __('Hide expired'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- Filter End -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm">
                            <thead>
                            <tr>
                                <th class="no-sort text-center"><i class="fa fa-check-square"></i></th>
                                <th class="no-sort"><?php echo __('Running'); ?></th>
                                <th class="no-sort" ng-click="orderBy('DowntimeServices.author_name')">
                                    <i class="fa" ng-class="getSortClass('DowntimeServices.author_name')"></i>
                                    <?php echo __('User'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('DowntimeServices.comment_data')">
                                    <i class="fa" ng-class="getSortClass('DowntimeServices.comment_data')"></i>
                                    <?php echo __('Comment'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('DowntimeServices.entry_time')">
                                    <i class="fa" ng-class="getSortClass('DowntimeServices.entry_time')"></i>
                                    <?php echo __('Created'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('DowntimeServices.scheduled_start_time')">
                                    <i class="fa"
                                       ng-class="getSortClass('DowntimeServices.scheduled_start_time')"></i>
                                    <?php echo __('Start'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('DowntimeServices.scheduled_end_time')">
                                    <i class="fa" ng-class="getSortClass('DowntimeServices.scheduled_end_time')"></i>
                                    <?php echo __('End'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('DowntimeServices.duration')">
                                    <i class="fa" ng-class="getSortClass('DowntimeServices.duration')"></i>
                                    <?php echo __('Duration'); ?>
                                </th>
                                <th class="no-sort" ng-click="orderBy('DowntimeServices.was_cancelled')">
                                    <i class="fa" ng-class="getSortClass('DowntimeServices.was_cancelled')"></i>
                                    <?php echo __('Was cancelled'); ?>
                                </th>
                                <th class="no-sort"><?php echo __('Cancel'); ?></th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr ng-repeat="downtime in downtimes">
                                <td class="width-5">
                                    <input type="checkbox"
                                           ng-model="massChange[downtime.internal_downtime_id]"
                                           ng-show="downtime.is_cancellable">
                                </td>

                                <td class="text-center">
                                    <downtimeicon downtime="downtime"></downtimeicon>
                                </td>
                                <td>
                                    {{downtime.author_name}}
                                </td>

                                <td>
                                    {{downtime.comment_data}}
                                </td>

                                <td>
                                    {{downtime.entry_time}}
                                </td>

                                <td>
                                    {{downtime.scheduled_start_time}}
                                </td>

                                <td>
                                    {{downtime.scheduled_end_time}}
                                </td>

                                <td>
                                    {{downtime.duration_for_humans}}
                                </td>

                                <td>
                                    <span ng-if="downtime.was_cancelled"><?php echo __('Yes'); ?></span>
                                    <span ng-if="!downtime.was_cancelled"><?php echo __('No'); ?></span>
                                </td>

                                <td>
                                    <?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
                                        <button
                                                class="btn btn-xs btn-danger"
                                                ng-if="downtime.is_cancellable"
                                                ng-click="confirmServiceDowntimeDelete(getObjectForDelete(downtime))">
                                            <i class="fa fa-trash"></i> <?php echo __('Cancel'); ?>
                                        </button>
                                    <?php endif; ?>
                                </td>

                            </tr>

                            <tr>
                            </tbody>
                        </table>

                        <div class="margin-top-10" ng-show="downtimes.length == 0">
                            <div class="text-center text-danger italic">
                                <?php echo __('No entries match the selection'); ?>
                            </div>
                        </div>

                        <?php if ($this->Acl->hasPermission('cancel_downtime', 'externalcommands')): ?>
                            <div class="row margin-top-10 margin-bottom-10">
                                <div class="col-xs-12 col-md-2 text-muted text-center">
                                    <span ng-show="selectedElements > 0">({{selectedElements}})</span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                <span ng-click="selectAll()" class="pointer">
                                    <i class="fas fa-lg fa-check-square"></i>
                                    <?php echo __('Select all'); ?>
                                </span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                <span ng-click="undoSelection()" class="pointer">
                                    <i class="fas fa-lg fa-square"></i>
                                    <?php echo __('Undo selection'); ?>
                                </span>
                                </div>
                                <div class="col-xs-12 col-md-2 txt-color-red">
                                    <span ng-click="confirmServiceDowntimeDelete(getObjectsForDelete())"
                                          class="pointer">
                                        <i class="fas fa-trash"></i>
                                        <?php echo __('Cancel selected'); ?>
                                    </span>
                                </div>
                            </div>
                        <?php endif; ?>
                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
