<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <a ui-sref="HostsIndex">
            <i class="fas fa-desktop"></i> <?php echo __('Hosts'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-stethoscope"></i> <?php echo __('Monitored'); ?>
    </li>
</ol>

<div ng-init="flashMshStr='<?php echo __('Command sent successfully. Refresh in 5 seconds'); ?>'"></div>

<?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
    <reschedule-host callback="showFlashMsg"></reschedule-host>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
    <host-downtime callback="showFlashMsg"></host-downtime>
<?php endif; ?>

<?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
    <acknowledge-host callback="showFlashMsg"></acknowledge-host>
<?php endif; ?>

<div class="row">
    <div class="col-xl-12">
        <div id="widget-container" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Hosts'); ?>
                    <span class="fw-300">
                        <i><?php echo __('overview'); ?></i>
                    </span>
                </h2>

                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show ">
                <div class="panel-content">
                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-desktop"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by host name'); ?>"
                                                   ng-model="filter_host_name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by output'); ?>"
                                                   ng-model="filter_output"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>

                            </div>

                            <div class="row">

                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('Hoststatus'); ?></h5>
                                        <div class="form-group">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterUp"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateUp"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-ok"
                                                       for="statusFilterUp"><?php echo __('Up'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterDown"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateDown"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-down"
                                                       for="statusFilterDown"><?php echo __('Down'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterUnreachable"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateUnreachable"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-unreachable"
                                                       for="statusFilterUnreachable"><?php echo __('Unknown'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>

                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('Acknowledgements'); ?></h5>
                                        <div class="form-group">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="ackFilterAck"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.Hoststatus.acknowledged"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="ackFilterAck"><?php echo __('Acknowledge'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="ackFilterNotAck"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.Hoststatus.not_acknowledged"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="ackFilterNotAck"><?php echo __('Not acknowledged'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>

                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('Downtimes'); ?></h5>
                                        <div class="form-group smart-form">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="downtimwFilterInDowntime"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.Hoststatus.in_downtime"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="downtimwFilterInDowntime"><?php echo __('In downtime'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="downtimwFilterNotInDowntime"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="filter.Hoststatus.not_in_downtime"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label"
                                                       for="downtimwFilterNotInDowntime"><?php echo __('Not in downtime'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm" role="grid">
                            <thead>
                            <tr>
                                <th ng-click="orderBy('current_state')" class="width-100 cursor-pointer" colspan="2">
                                    <i class="fa" ng-class="getSortClass('current_state')"></i>
                                    <?php echo __('Hoststatus'); ?>
                                </th>

                                <th class="no-sort text-center">
                                    <i class="fa fa-user" title="<?php echo __('is acknowledged'); ?>"></i>
                                </th>

                                <th class="no-sort text-center">
                                    <i class="fa fa-power-off"
                                       title="<?php echo __('is in downtime'); ?>"></i>
                                </th>

                                <th ng-click="orderBy('HostMapping.display_name')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('HostMapping.display_name')"></i>
                                    <?php echo __('Host name'); ?>
                                </th>
                                <th ng-click="orderBy('active_checks_enabled')" class="width-40 cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('active_checks_enabled')"></i>
                                    <strong title="<?php echo __('Passively transferred host'); ?>">
                                        <?php echo __('P'); ?>
                                    </strong>
                                </th>
                                <th ng-click="orderBy('last_state_change')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('last_state_change')"></i>
                                    <?php echo __('State since'); ?>
                                </th>
                                <th ng-click="orderBy('last_check')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('last_check')"></i>
                                    <?php echo __('Last check'); ?>
                                </th>
                                <th ng-click="orderBy('next_check')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('next_check')"></i>
                                    <?php echo __('Next check'); ?>
                                </th>
                                <th ng-click="orderBy('output')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('output')"></i>
                                    <?php echo __('Output'); ?>
                                </th>
                                <th>
                                    <?php echo __('Service Summary'); ?>
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr ng-repeat="host in hoststatus">
                                <td class="width-5">
                                    <?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands') || $this->Acl->hasPermission('schedule_maintenance', 'externalcommands') || $this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
                                        <input type="checkbox"
                                               ng-model="massChange[host.hostname]">
                                    <?php endif; ?>
                                </td>
                                <td class="text-center">
                                    <hoststatusicon state="host.current_state"
                                                    is-flapping="host.is_flapping"></hoststatusicon>
                                </td>

                                <td class="text-center">
                                    <i class="far fa-user"
                                       ng-show="host.problem_has_been_acknowledged"
                                       ng-if="host.acknowledgement_type == 1"></i>

                                    <i class="fas fa-user"
                                       ng-show="host.problem_has_been_acknowledged"
                                       ng-if="host.acknowledgement_type == 2"
                                       title="<?php echo __('Sticky Acknowledgedment'); ?>"></i>
                                </td>

                                <td class="text-center">
                                    <i class="fa fa-power-off"
                                       ng-show="host.scheduled_downtime_depth > 0"></i>
                                </td>

                                <td>
                                    <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
                                        <a ui-sref="HostsBrowser({uuid:host.hostname})">
                                            {{ host.host_mapping.display_name }}
                                        </a>
                                    <?php else: ?>
                                        {{ host.host_mapping.display_name }}
                                    <?php endif; ?>
                                </td>
                                <td class="text-center">
                                    <strong title="<?php echo __('Passively transferred host'); ?>"
                                            ng-hide="host.active_checks_enabled">
                                        <?php echo __('P'); ?>
                                    </strong>
                                </td>
                                <td>
                                    {{ host.last_state_change }}
                                </td>
                                <td>
                                    {{ host.last_check }}
                                </td>
                                <td>
                                    <span ng-show="host.active_checks_enabled">
                                        {{ host.next_check }}
                                    </span>
                                </td>
                                <td>
                                    <div
                                            ng-bind-html="host.output_html | trustAsHtml"></div>
                                </td>
                                <td class="width-160">
                                    <div class="btn-group btn-group-justified" role="group" style="width: 100%">
                                        <?php if ($this->Acl->hasPermission('index', 'services')): ?>
                                            <a ui-sref="ServicesIndex({'statename':'ok', hostdisplayname:'{{ host.host_mapping.display_name | encodeURI }}'})"
                                               class="btn btn-success state-button-small">
                                                {{host.servicestatus_summary.ok}}
                                            </a>
                                        <?php else: ?>
                                            <span class="btn btn-success state-button-small">
                                                {{host.servicestatus_summary.ok}}
                                            </span>
                                        <?php endif; ?>
                                        <?php if ($this->Acl->hasPermission('index', 'services')): ?>
                                            <a ui-sref="ServicesIndex({'statename':'warning', 'hostdisplayname':'{{ host.host_mapping.display_name | encodeURI }}'})"
                                               class="btn btn-warning state-button-small">
                                                {{host.servicestatus_summary.warning}}
                                            </a>
                                        <?php else: ?>
                                            <span class="btn btn-warning state-button-small">
                                                {{host.servicestatus_summary.warning}}
                                            </span>
                                        <?php endif; ?>
                                        <?php if ($this->Acl->hasPermission('index', 'services')): ?>
                                            <a ui-sref="ServicesIndex({'statename':'critical', 'hostdisplayname':'{{ host.host_mapping.display_name | encodeURI }}'})"
                                               class="btn btn-danger state-button-small">
                                                {{host.servicestatus_summary.critical}}
                                            </a>
                                        <?php else: ?>
                                            <span class="btn btn-danger state-button-small">
                                                {{host.servicestatus_summary.critical}}
                                            </span>
                                        <?php endif; ?>
                                        <?php if ($this->Acl->hasPermission('index', 'services')): ?>
                                            <a ui-sref="ServicesIndex({'statename':'unknown', 'hostdisplayname':'{{ host.host_mapping.display_name | encodeURI }}'})"
                                               class="btn btn-default state-button-small">
                                                {{host.servicestatus_summary.unknown}}
                                            </a>
                                        <?php else: ?>
                                            <span class="btn btn-default state-button-small">
                                                {{host.servicestatus_summary.unknown}}
                                            </span>
                                        <?php endif; ?>
                                    </div>
                                </td>
                            </tr>

                            <tr ng-show="hoststatus.length == 0">
                                <td colspan="11" class="text-center txt-color-red">
                                    <?php echo __('No results found'); ?>
                                </td>
                            </tr>

                            </tbody>
                        </table>
                        <?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands') || $this->Acl->hasPermission('schedule_maintenance', 'externalcommands') || $this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
                            <div class="row margin-top-10 margin-bottom-10">
                                <div class="col-xs-12 col-md-2 text-muted text-center">
                                    <span ng-show="selectedElements > 0">({{selectedElements}})</span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                <span ng-click="selectAll()" class="pointer">
                                    <i class="fas fa-lg fa-check-square"></i>
                                    <?php echo __('Select all'); ?>
                                </span>
                                </div>
                                <div class="col-xs-12 col-md-2">
                                <span ng-click="undoSelection()" class="pointer">
                                    <i class="fas fa-lg fa-square"></i>
                                    <?php echo __('Undo selection'); ?>
                                </span>
                                </div>
                                <div class="btn-group btn-group-sm">
                                    <button class="btn btn-default dropdown-toggle waves-effect waves-themed"
                                            type="button"
                                            data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                                        <?php echo __('Actions'); ?>
                                    </button>
                                    <div class="dropdown-menu" x-placement="bottom-start">
                                        <?php if ($this->Acl->hasPermission('reset_check_time', 'externalcommands')): ?>
                                            <a class="dropdown-item" href="javascript:void(0);"
                                               ng-click="rescheduleHost(getObjectsForExternalCommand())">
                                                <i class="fa fa-refresh"></i> <?php echo __('Reset check time'); ?>
                                            </a>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('schedule_maintenance', 'externalcommands')): ?>
                                            <a class="dropdown-item" href="javascript:void(0);"
                                               ng-click="hostDowntime(getObjectsForExternalCommand())">
                                                <i class="fa fa-clock-o"></i> <?php echo __('Set planned maintenance times'); ?>
                                            </a>
                                        <?php endif; ?>

                                        <?php if ($this->Acl->hasPermission('acknowledge_status', 'externalcommands')): ?>
                                            <a class="dropdown-item" href="javascript:void(0);"
                                               ng-click="acknowledgeHost(getObjectsForExternalCommand())">
                                                <i class="fa fa-user"></i> <?php echo __('Acknowledge host status'); ?>
                                            </a>
                                        <?php endif; ?>
                                    </div>
                                </div>
                            </div>
                        <?php endif; ?>

                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
