<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'services')): ?>
            <a ui-sref="ServicesIndex">
                <i class="fas fa-cogs"></i> <?php echo __('Services'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-cogs"></i> <?php echo __('Services'); ?>
        <?php endif; ?>
    </li>
    <li class="breadcrumb-item">
        <i class="fa-solid fa-wand-magic-sparkles fa-fw"></i> <?php echo __('Auto Maps'); ?>
    </li>
</ol>

<div class="row">
    <div class="col-xl-12">
        <div id="widget-container" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Auto map'); ?>
                    <span class="fw-300">
                        <i><?php echo __('overview'); ?></i>
                    </span>

                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="minified = !minified">
                        <i class="fas fa-braille"></i>
                        <?php echo __('Minified'); ?>
                    </button>
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="showLabel = !showLabel"
                            ng-hide="minified">
                        <i class="fas fa-tag"></i>
                        <?php echo __('Show label'); ?>
                    </button>
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>

                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-desktop"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by host name'); ?>"
                                                   ng-model="filter_host_name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fas fa-cogs"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by service name'); ?>"
                                                   ng-model="filter_service_name"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('Service status'); ?></h5>
                                        <div class="form-group">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterOk"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateOk"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-ok"
                                                       for="statusFilterOk"><?php echo __('Ok'); ?></label>
                                            </div>
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterWarning"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateWarning"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-warning"
                                                       for="statusFilterWarning"><?php echo __('Warning'); ?></label>
                                            </div>
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterCritical"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateCritical"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-critical"
                                                       for="statusFilterCritical"><?php echo __('Critical'); ?></label>
                                            </div>
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterUnknown"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateUnknown"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-unknown"
                                                       for="statusFilterUnknown"><?php echo __('Unknown'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <div ng-if="!minified">
                            <div class="padding-bottom-20 form-group" ng-repeat="host in services"
                                 style="padding: 1rem 1rem;">
                                <div class="border-bottom-dashed">
                                    <h4 ng-click="showHostDetails(host)" class="cursor-pointer">
                                        <hoststatusicon-automap is-flapping="host.hoststatus.is_flapping"
                                                                hoststatus="host.hoststatus">
                                        </hoststatusicon-automap>
                                        {{ host.display_name }}
                                    </h4>
                                </div>
                                <div class="row padding-10">
                                    <div class="col-xs-12 col-md-4 col-lg-3 ellipsis pointer"
                                         ng-repeat="service in host.servicestatus"
                                         ng-if="showLabel"
                                         ng-click="showServiceDetails(service)">
                                        <servicestatusicon-automap is-flapping="service.is_flapping"
                                                                   servicestatus="service">
                                        </servicestatusicon-automap>
                                        {{ service.ServiceMapping.display_name }}
                                    </div>
                                </div>

                                <div class="col-xs-12 padding-10 pointer" ng-if="!showLabel">
                                    <div ng-repeat="service in host.servicestatus"
                                         title="{{ host.display_name }}/{{ service.service_mapping.display_name }}"
                                         class="display-inline-noblock"
                                         ng-click="showServiceDetails(service)">
                                        <servicestatusicon-automap is-flapping="service.is_flapping"
                                                                   servicestatus="service">

                                        </servicestatusicon-automap>
                                    </div>
                                </div>
                            </div>
                        </div>

                        <div ng-if="minified">
                            <div class="row" style="padding: 1rem 1rem;">
                                <div ng-repeat="host in services"
                                     title="{{ host.display_name }}"
                                     class="display-inline-noblock">
                                    <i class="fa fa-desktop" aria-hidden="true"></i>
                                    <div class="display-inline-noblock"
                                         ng-click="showHostDetails(host)">
                                        <hoststatusicon-automap is-flapping="host.hoststatus.is_flapping"
                                                                hoststatus="host.hoststatus">
                                    </div>
                                    <i class="fa fa-cogs" aria-hidden="true"></i>


                                    <div ng-repeat="service in host.servicestatus"
                                         class="display-inline-noblock"
                                         title="{{ host.display_name }}/{{ service.ServiceMapping.display_name }}"
                                         ng-click="showServiceDetails(service)">
                                        <servicestatusicon-automap
                                                servicestatus="service"
                                                is-flapping="service.is_flapping">
                                        </servicestatusicon-automap>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>

                    <div class="col-xs-12 txt-color-red text-center padding-top-15" ng-show="services.length == 0">
                        <?php echo __('No results found'); ?>
                    </div>

                </div>
            </div>
        </div>
    </div>
</div>
<host-status-details-modal></host-status-details-modal>
<service-status-details-modal></service-status-details-modal>
