<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fa fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'hosts')): ?>
            <a ui-sref="HostsIndex">
                <i class="fas fa-desktop"></i> <?php echo __('Hosts'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-desktop"></i> <?php echo __('Hosts'); ?>
        <?php endif; ?>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('browser', 'hosts')): ?>
            <a ui-sref="HostsBrowser({uuid: hoststatus.hostname})">
                <i class="fa fa-stethoscope"></i> <?php echo __('Details'); ?>
            </a>
        <?php else: ?>
            <i class="fa fa-stethoscope"></i> <?php echo __('Details'); ?>
        <?php endif; ?>
    </li>
    <li class="breadcrumb-item">
        <i class="fa fa-history"></i> <?php echo __('State history'); ?>
    </li>
</ol>

<hostmenu hoststatus="hoststatus" showbackbutton="true" ng-if="hoststatus"></hostmenu>

<div class="row">
    <div class="col-xl-12">
        <div id="widget-container" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Hosts'); ?>
                    <span class="fw-300">
                        <i><?php echo __('state history'); ?></i>
                    </span>
                </h2>
                <div class="panel-toolbar">
                    <button class="btn btn-xs btn-default mr-1 shadow-0" ng-click="load()">
                        <i class="fas fa-sync"></i> <?php echo __('Refresh'); ?>
                    </button>
                    <button class="btn btn-xs btn-primary shadow-0" ng-click="triggerFilter()">
                        <i class="fas fa-filter"></i> <?php echo __('Filter'); ?>
                    </button>
                </div>
            </div>
            <div class="panel-container show">
                <div class="panel-content">
                    <!-- Start Filter -->
                    <div class="list-filter card margin-bottom-10" ng-show="showFilter">
                        <div class="card-header">
                            <i class="fa fa-filter"></i> <?php echo __('Filter'); ?>
                        </div>
                        <div class="card-body">
                            <div class="row">
                                <div class="col-xs-12 col-md-6 margin-bottom-10">
                                    <div class="form-group">
                                        <div class="input-group">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><i class="fa fa-filter"></i></span>
                                            </div>
                                            <input type="text" class="form-control form-control-sm"
                                                   placeholder="<?php echo __('Filter by output'); ?>"
                                                   ng-model="filter_output"
                                                   ng-model-options="{debounce: 500}">
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-xs-12 col-lg-3">
                                    <fieldset>
                                        <h5><?php echo __('Host status'); ?></h5>
                                        <div class="form-group">
                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterUp"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateUp"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-ok"
                                                       for="statusFilterUp"><?php echo __('Up'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterDown"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateDown"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-down"
                                                       for="statusFilterDown"><?php echo __('Down'); ?></label>
                                            </div>

                                            <div class="custom-control custom-checkbox">
                                                <input type="checkbox"
                                                       id="statusFilterUnreachable"
                                                       class="custom-control-input"
                                                       name="checkbox"
                                                       checked="checked"
                                                       ng-model="stateUnreachable"
                                                       ng-model-options="{debounce: 500}">
                                                <label class="custom-control-label custom-control-label-unreachable"
                                                       for="statusFilterUnreachable"><?php echo __('Unknown'); ?></label>
                                            </div>
                                        </div>
                                    </fieldset>
                                </div>
                            </div>
                            <div class="float-right">
                                <button type="button" ng-click="resetFilter()"
                                        class="btn btn-xs btn-danger">
                                    <?php echo __('Reset Filter'); ?>
                                </button>
                            </div>
                        </div>
                    </div>
                    <!-- End Filter -->

                    <div class="frame-wrap">
                        <table class="table table-striped m-0 table-bordered table-hover table-sm" role="grid">
                            <thead>
                            <tr>
                                <th ng-click="orderBy('state')" class="width-120 cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('state')"></i>
                                    <?php echo __('State'); ?>
                                </th>
                                <th ng-click="orderBy('state_time')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('state_time')"></i>
                                    <?php echo __('Date'); ?>
                                </th>
                                <th class="width-120">
                                    <?php echo __('Check attempt'); ?>
                                </th>
                                <th class="width-80" ng-click="orderBy('is_hardstate')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('is_hardstate')"></i>
                                    <?php echo __('State type'); ?>
                                </th>
                                <th ng-click="orderBy('output')" class="cursor-pointer">
                                    <i class="fa" ng-class="getSortClass('output')"></i>
                                    <?php echo __('Output'); ?>
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                            <tr ng-repeat="host in hoststatehistory">
                                <td class="text-center">
                                    <hoststatusicon state="host.state"></hoststatusicon>
                                </td>
                                <td>
                                    {{ host.state_time }}
                                </td>
                                <td> {{host.current_check_attempt}}/{{host.max_check_attempts}}</td>
                                <td>
                                    <span
                                            class="badge text-uppercase badge-{{ getColorOfState(host.state) }}"
                                            ng-show="host.is_hardstate">
                                        <?php echo __('hard state'); ?>
                                    </span>
                                    <span
                                            class="badge text-uppercase opacity-50 badge-{{ getColorOfState(host.state) }}"
                                            ng-show="!host.is_hardstate">
                                        <?php echo __('soft state'); ?>
                                    </span>
                                </td>
                                <td> {{ host.output }}</td>
                            </tr>
                            </tbody>
                        </table>
                        <scroll scroll="scroll" click-action="changepage" ng-if="scroll"></scroll>
                        <paginator paging="paging" click-action="changepage" ng-if="paging"></paginator>
                        <?php echo $this->element('paginator_or_scroll'); ?>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
