<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
$timezones = \itnovum\openITCOCKPIT\Core\Timezone::listTimezones();
?>
<ol class="breadcrumb page-breadcrumb">
    <li class="breadcrumb-item">
        <a ui-sref="DashboardsIndex">
            <i class="fas fa-home"></i> <?php echo __('Home'); ?>
        </a>
    </li>
    <li class="breadcrumb-item">
        <?php if ($this->Acl->hasPermission('index', 'users')): ?>
            <a ui-sref="UsersIndex">
                <i class="fas fa-user"></i> <?php echo __('Users'); ?>
            </a>
        <?php else: ?>
            <i class="fas fa-user"></i> <?php echo __('Users'); ?>
        <?php endif; ?>
    </li>
    <li class="breadcrumb-item">
        <i class="fas fa-edit"></i> <?php echo __('Edit'); ?>
    </li>
</ol>

<div class="row">
    <div class="col-xl-12">
        <div id="panel-1" class="panel">
            <div class="panel-hdr">
                <h2>
                    <?php echo __('Edit local user:'); ?>
                    <span class="fw-300"><i>
                            {{post.User.firstname}},
                            {{post.User.lastname}}
                        </i></span>
                </h2>
                <div class="panel-toolbar">
                    <?php if ($this->Acl->hasPermission('index', 'users')): ?>
                        <a back-button href="javascript:void(0);" fallback-state='UsersIndex'
                           class="btn btn-default btn-xs mr-1 shadow-0">
                            <i class="fas fa-long-arrow-alt-left"></i> <?php echo __('Back'); ?>
                        </a>
                    <?php endif; ?>
                </div>
            </div>

            <div class="panel-container show">
                <div class="panel-content">
                    <form ng-submit="submit();" class="form-horizontal"
                          ng-init="successMessage={objectName : '<?php echo __('User'); ?>' , message: '<?php echo __('saved successfully'); ?>'}">
                        <div class="widget-body smart-form no-padding">
                            <div class="col-12">

                                <div class="form-group required" ng-class="{'has-error': errors.usergroup_id}">
                                    <label class="control-label" for="Usergroups">
                                        <?php echo __('User role'); ?>
                                    </label>
                                    <select
                                            id="Usergroups"
                                            data-placeholder="<?php echo __('Please choose'); ?>"
                                            class="form-control"
                                            chosen="usergroups"
                                            ng-options="usergroup.key as usergroup.value for usergroup in usergroups"
                                            ng-model="post.User.usergroup_id">
                                    </select>
                                    <div ng-repeat="error in errors.usergroup_id">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group required" ng-class="{'has-error': errors.username}">
                                    <label class="control-label">
                                        <?php echo __('Username'); ?>
                                    </label>
                                    <input
                                            class="form-control"
                                            type="text"
                                            ng-model="post.User.username">
                                    <div ng-repeat="error in errors.username">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group required" ng-class="{'has-error': errors.firstname}">
                                    <label class="control-label">
                                        <?php echo __('First name'); ?>
                                    </label>
                                    <input
                                            class="form-control"
                                            type="text"
                                            ng-model="post.User.firstname">
                                    <div ng-repeat="error in errors.firstname">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group required" ng-class="{'has-error': errors.lastname}">
                                    <label class="control-label">
                                        <?php echo __('Last name'); ?>
                                    </label>
                                    <input
                                            class="form-control"
                                            type="text"
                                            ng-model="post.User.lastname">
                                    <div ng-repeat="error in errors.lastname">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group" ng-class="{'has-error': errors.paginatorlength}">
                                    <label class="control-label">
                                        <?php echo __('Length of lists'); ?>
                                    </label>
                                    <input
                                            class="form-control"
                                            type="number"
                                            ng-model="post.User.paginatorlength">
                                    <div ng-repeat="error in errors.paginatorlength">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group" ng-class="{'has-error': errors.showstatsinmenu}">
                                    <div class="custom-control custom-checkbox  margin-bottom-10"
                                         ng-class="{'has-error': errors.showstatsinmenu}">

                                        <input type="checkbox"
                                               class="custom-control-input"
                                               id="userShowstatsinmenu"
                                               ng-model="post.User.showstatsinmenu">
                                        <label class="custom-control-label" for="userShowstatsinmenu">
                                            <?php echo __('Show status badges in menu'); ?>
                                        </label>
                                    </div>
                                </div>

                                <div class="form-group required" ng-class="{'has-error': errors.dateformat}">
                                    <label class="control-label" for="UserDateformat">
                                        <?php echo __('Date format'); ?>
                                    </label>
                                    <select
                                            id="UserDateformat"
                                            data-placeholder="<?php echo __('Please choose'); ?>"
                                            class="form-control"
                                            chosen="dateformats"
                                            ng-options="dateformat.key as dateformat.value for dateformat in dateformats"
                                            ng-model="post.User.dateformat">
                                    </select>
                                    <div ng-repeat="error in errors.dateformat">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group required" ng-class="{'has-error': errors.timezone}">
                                    <label class="control-label" for="UserTimezone">
                                        <?php echo __('Timezone'); ?>
                                    </label>
                                    <select
                                            id="UserTimezone"
                                            data-placeholder="<?php echo __('Please choose'); ?>"
                                            class="form-control"
                                            chosen="{}"
                                            ng-model="post.User.timezone">
                                        <?php foreach ($timezones as $continent => $continentTimezones): ?>
                                            <optgroup label="<?php echo h($continent); ?>">
                                                <?php foreach ($continentTimezones as $timezoneKey => $timezoneName): ?>
                                                    <option
                                                            value="<?php echo h($timezoneKey); ?>"><?php echo h($timezoneName); ?></option>
                                                <?php endforeach; ?>
                                            </optgroup>
                                        <?php endforeach; ?>
                                    </select>
                                    <div ng-repeat="error in errors.User.timezone">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>

                                    <div class="help-block">
                                        <br/>
                                        <?php echo __('Server timezone is:'); ?>
                                        <strong>
                                            <?php echo h(date_default_timezone_get()); ?>
                                        </strong>
                                        <?php echo __('Current server time:'); ?>
                                        <strong>
                                            <?php echo date('d.m.Y H:i:s'); ?>
                                        </strong>
                                    </div>
                                </div>

                                <hr/>

                                <div class="form-group required" ng-class="{'has-error': errors.password}">
                                    <label class="control-label">
                                        <?php echo __('New password'); ?>
                                    </label>
                                    <input
                                            class="form-control"
                                            type="password"
                                            ng-model="post.User.password"
                                            autocomplete="new-password">
                                    <div ng-repeat="error in errors.password">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>

                                <div class="form-group required" ng-class="{'has-error': errors.confirm_password}">
                                    <label class="control-label">
                                        <?php echo __('Confirm new password'); ?>
                                    </label>
                                    <input
                                            class="form-control"
                                            type="password"
                                            ng-model="post.User.confirm_password"
                                            autocomplete="new-password">
                                    <div ng-repeat="error in errors.confirm_password">
                                        <div class="help-block text-danger">{{ error }}</div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="card margin-top-10">
                            <div class="card-body">
                                <div class="float-right">
                                    <button class="btn btn-primary"
                                            type="submit"><?php echo __('Update user'); ?></button>
                                    <a back-button href="javascript:void(0);" fallback-state='UsersIndex'
                                       class="btn btn-default"><?php echo __('Cancel'); ?></a>
                                </div>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
