<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
namespace itnovum\openITCOCKPIT\Core;


use itnovum\openITCOCKPIT\Core\ValueObjects\HostStates;

class AcknowledgedHostConditions extends ListSettingsConditions {

    protected $states = [
        0, 1, 2
    ];

    /**
     * @var string
     */
    protected $hostUuid;

    /**
     * @var bool
     */
    private $useLimit = true;

    /**
     * @param string $hostUuid
     */
    public function setHostUuid($hostUuid) {
        $this->hostUuid = $hostUuid;
    }

    /**
     * @return string
     */
    public function getHostUuid() {
        return $this->hostUuid;
    }

    /**
     * @param $value
     */
    public function setUseLimit($value) {
        $this->useLimit = (bool)$value;
    }

    /**
     * @return bool
     */
    public function getUseLimit() {
        return $this->useLimit;
    }

    /**
     * @param HostStates $HostStates
     */
    public function setStates(HostStates $HostStates) {
        if (sizeof($HostStates->asIntegerArray()) == 3) {
            $this->states = [];
            return;
        }

        $this->states = $HostStates->asIntegerArray();
    }

}

