<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.

namespace itnovum\openITCOCKPIT\Core\AngularJS\Request;

use App\Filter\BaseFilter;

class AcknowledgementsControllerRequest extends AngularRequest {

    /**
     * @var array
     */
    protected $filters = [
        'host'    => [
            'like'   => [
                'AcknowledgementHosts.comment_data',
                'AcknowledgementHosts.author_name'
            ],
            'equals' => [
                'AcknowledgementHosts.hostname'
            ]
        ],
        'service' => [
            'like' => [
                'AcknowledgementServices.comment_data',
                'AcknowledgementServices.author_name'
            ]
        ]
    ];

    protected $ServiceStateField = 'AcknowledgementServices.state';

    protected $HostStateField = 'AcknowledgementHosts.state';

    public function getServiceFilters() {
        $Filter = new BaseFilter($this->getRequest());
        return $Filter->getConditionsByFilters($this->filters['service']);
    }

    public function getHostFilters() {
        $Filter = new BaseFilter($this->getRequest());
        return $Filter->getConditionsByFilters($this->filters['host']);
    }

}
