<?php
// Copyright (C) <2015-present>  <it-novum GmbH>
//
// This file is licensed under the terms of the openITCOCKPIT Enterprise Edition license agreement.
// The license agreement and license key were sent with the order confirmation.
namespace itnovum\openITCOCKPIT\Core\Views;

/**
 * Class Apikey
 * @package itnovum\openITCOCKPIT\Core\Views
 */
class Apikey {

    private $id = null;

    private $userId = null;

    private $apikey = null;

    private $description = null;

    /**
     * Apikey constructor.
     * @param array $apikey
     */
    public function __construct($apikey) {
        if (isset($apikey['id'])) {
            $this->id = (int)$apikey['id'];
        }

        if (isset($apikey['user_id'])) {
            $this->userId = (int)$apikey['user_id'];
        }

        if (isset($apikey['apikey'])) {
            $this->apikey = $apikey['apikey'];
        }

        if (isset($apikey['description'])) {
            $this->description = $apikey['description'];
        }

    }

    /**
     * @return int|null
     */
    public function getId() {
        return $this->id;
    }

    /**
     * @return int|null
     */
    public function getUserId() {
        return $this->userId;
    }

    /**
     * @return null
     */
    public function getApikey() {
        return $this->apikey;
    }

    /**
     * @return null
     */
    public function getDescription() {
        return $this->description;
    }


    /**
     * @return array
     */
    public function toArray() {
        $arr = get_object_vars($this);
        return $arr;
    }

}
