#!/bin/bash

/bin/systemctl restart nagios.service

if [ -f /opt/openitc/frontend/bin/cake ]; then
    /opt/openitc/frontend/bin/cake mapping_import
fi

if [ -f /opt/openitc/nagios/etc/agent_production.json ]; then
    if [ -d /opt/openitc/receiver/etc/ ]; then
        cp /opt/openitc/nagios/etc/agent_production.json /opt/openitc/receiver/etc/production.json
    fi
fi


if [ "$(docker ps -q -f 'name=openitcockpit-checkmk')" ]; then

    # Delete autochecks
    if [ -d /opt/openitc/check_mk/var/check_mk/autochecks ]; then
        find /opt/openitc/check_mk/var/check_mk/autochecks/ -type f -delete
    fi

    # Copy new config in place
    if [ -d /opt/openitc/nagios/etc/check_mk ]; then
        rsync -amr --timeout=10 --delete /opt/openitc/nagios/etc/check_mk/etc/ /opt/openitc/check_mk/etc/
    fi

	# Checkmk container is running compile Checkmk checks
	# -U, --update is the same as -C in older Checkmk versions
	curl --noproxy '127.0.0.1' -X POST http://127.0.0.1:1234 -d "-U"
fi

if [ -f /opt/openitc/nagios/etc/push_agents_import_module.json ]; then
    /opt/openitc/frontend/bin/cake agent --assign-from-json
fi

exit $?
