<?php

namespace App\Test\Fixture;

use Cake\TestSuite\Fixture\TestFixture;

/**
 * HoststatusFixture
 *
 */
class HoststatusFixture extends TestFixture {

    /**
     * Table name
     *
     * @var string
     */
    public $table = 'statusengine_hoststatus';

    /**
     * Fields
     *
     * @var array
     */
    // @codingStandardsIgnoreStart
    public $fields = [
        'hostname'                      => ['type' => 'string', 'length' => 255, 'null' => false, 'default' => '', 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        'status_update_time'            => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'output'                        => ['type' => 'string', 'length' => 1024, 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        'long_output'                   => ['type' => 'string', 'length' => 1024, 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        'perfdata'                      => ['type' => 'string', 'length' => 1024, 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        'current_state'                 => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'current_check_attempt'         => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'max_check_attempts'            => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'last_check'                    => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'next_check'                    => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'is_passive_check'              => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'last_state_change'             => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'last_hard_state_change'        => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'last_hard_state'               => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'is_hardstate'                  => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'last_notification'             => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'next_notification'             => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'notifications_enabled'         => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'problem_has_been_acknowledged' => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'acknowledgement_type'          => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'passive_checks_enabled'        => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'active_checks_enabled'         => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'event_handler_enabled'         => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'flap_detection_enabled'        => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'is_flapping'                   => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'latency'                       => ['type' => 'float', 'length' => null, 'precision' => null, 'unsigned' => false, 'null' => true, 'default' => '0', 'comment' => ''],
        'execution_time'                => ['type' => 'float', 'length' => null, 'precision' => null, 'unsigned' => false, 'null' => true, 'default' => '0', 'comment' => ''],
        'scheduled_downtime_depth'      => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'process_performance_data'      => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'obsess_over_host'              => ['type' => 'boolean', 'length' => null, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null],
        'normal_check_interval'         => ['type' => 'integer', 'length' => 11, 'unsigned' => true, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'retry_check_interval'          => ['type' => 'integer', 'length' => 11, 'unsigned' => true, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'check_timeperiod'              => ['type' => 'string', 'length' => 255, 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        'node_name'                     => ['type' => 'string', 'length' => 255, 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        'last_time_up'                  => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'last_time_down'                => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'last_time_unreachable'         => ['type' => 'biginteger', 'length' => 13, 'unsigned' => false, 'null' => false, 'default' => null, 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'current_notification_number'   => ['type' => 'integer', 'length' => 11, 'unsigned' => true, 'null' => true, 'default' => '0', 'comment' => '', 'precision' => null, 'autoIncrement' => null],
        'percent_state_change'          => ['type' => 'float', 'length' => null, 'precision' => null, 'unsigned' => false, 'null' => true, 'default' => '0', 'comment' => ''],
        'event_handler'                 => ['type' => 'string', 'length' => 255, 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        'check_command'                 => ['type' => 'string', 'length' => 255, 'null' => true, 'default' => null, 'collate' => 'utf8_general_ci', 'comment' => '', 'precision' => null, 'fixed' => null],
        '_constraints'                  => [
            'primary' => ['type' => 'primary', 'columns' => ['hostname'], 'length' => []],
        ],
        '_options'                      => [
            'engine'    => 'InnoDB',
            'collation' => 'utf8_general_ci'
        ],
    ];
    // @codingStandardsIgnoreEnd

    /**
     * Records
     *
     * @var array
     */
    public $records = [
        [
            'hostname'                      => '6233ec40-92d6-461b-8627-2fc70438767d',
            'status_update_time'            => 1,
            'output'                        => 'Lorem ipsum dolor sit amet',
            'long_output'                   => 'Lorem ipsum dolor sit amet',
            'perfdata'                      => 'Lorem ipsum dolor sit amet',
            'current_state'                 => 1,
            'current_check_attempt'         => 1,
            'max_check_attempts'            => 1,
            'last_check'                    => 1,
            'next_check'                    => 1,
            'is_passive_check'              => 1,
            'last_state_change'             => 1,
            'last_hard_state_change'        => 1,
            'last_hard_state'               => 1,
            'is_hardstate'                  => 1,
            'last_notification'             => 1,
            'next_notification'             => 1,
            'notifications_enabled'         => 1,
            'problem_has_been_acknowledged' => 1,
            'acknowledgement_type'          => 1,
            'passive_checks_enabled'        => 1,
            'active_checks_enabled'         => 1,
            'event_handler_enabled'         => 1,
            'flap_detection_enabled'        => 1,
            'is_flapping'                   => 1,
            'latency'                       => 1,
            'execution_time'                => 1,
            'scheduled_downtime_depth'      => 1,
            'process_performance_data'      => 1,
            'obsess_over_host'              => 1,
            'normal_check_interval'         => 1,
            'retry_check_interval'          => 1,
            'check_timeperiod'              => 'Lorem ipsum dolor sit amet',
            'node_name'                     => 'Lorem ipsum dolor sit amet',
            'last_time_up'                  => 1,
            'last_time_down'                => 1,
            'last_time_unreachable'         => 1,
            'current_notification_number'   => 1,
            'percent_state_change'          => 1,
            'event_handler'                 => 'Lorem ipsum dolor sit amet',
            'check_command'                 => 'Lorem ipsum dolor sit amet'
        ],
    ];
}
