angular.module('openITCOCKPIT')
    .controller('UsersAddController', function($scope, $http, $state, NotyService, RedirectService){
        $scope.data = {
            createAnother: false
        };
        $scope.localeOptions = [];

        var clearForm = function(){
            $scope.post = {
                User: {
                    usergroup_id: 0,
                    username: '',
                    firstname: '',
                    lastname: '',
                    showstatsinmenu: 0,
                    paginatorlength: 25,
                    dateformat: 'H:i:s - d.m.Y',
                    timezone: 'Europe/Berlin',
                    password: '',
                    password_confirm: ''
                }
            };
        };
        clearForm();

        $scope.loadUsergroups = function(){
            $http.get("/users/loadUsergroups.json", {
                params: {
                    'angular': true
                }
            }).then(function(result){
                $scope.usergroups = result.data.usergroups;
            });
        };

        $scope.loadDateformats = function(){
            $http.get("/users/loadDateformats.json", {
                params: {
                    'angular': true
                }
            }).then(function(result){
                $scope.dateformats = result.data.dateformats;
            });
        };

        $scope.submit = function(){

            $http.post("/users/add.json?angular=true",
                $scope.post
            ).then(function(result){
                var url = $state.href('UsersEdit', {id: result.data.user.id});
                NotyService.genericSuccess({
                    message: '<u><a href="' + url + '" class="txt-color-white"> '
                        + $scope.successMessage.objectName
                        + '</a></u> ' + $scope.successMessage.message
                });

                if($scope.data.createAnother === false){
                    RedirectService.redirectWithFallback('UsersIndex');
                }else{
                    clearForm();
                    $scope.errors = {};
                    NotyService.scrollTop();
                }

                console.log('Data saved successfully');
            }, function errorCallback(result){
                NotyService.genericError();
                if(result.data.hasOwnProperty('error')){
                    $scope.errors = result.data.error;
                }
            });
        };

        //Fire on pageload
        $scope.loadUsergroups();
        $scope.loadDateformats();
    });
