angular.module('openITCOCKPIT')
    .controller('UsersEditController', function($scope, $http, $state, $stateParams, NotyService){

        $scope.id = $stateParams.id;
        $scope.errors = {};

        $scope.load = function(){
            $http.get("/Users/edit/" + $scope.id + '.json').then(
                function(result){
                    $scope.post = {
                        User: result.data.user
                    }
                    $scope.post.User.password = '';
                    $scope.post.User.confirm_password = '';

                }, function errorCallback(result){
                    var message = 'An error has occurred!';
                    if(result.status === 404){
                        message = 'User not found!';
                    }
                    NotyService.genericError({
                        message: message
                    });
                    $state.go('users');
                });
        };

        $scope.loadUsergroups = function(){
            $http.get("/users/loadUsergroups.json", {
                params: {
                    'angular': true
                }
            }).then(function(result){
                $scope.usergroups = result.data.usergroups;
            });
        };

        $scope.loadDateformats = function(){
            $http.get("/users/loadDateformats.json", {
                params: {
                    'angular': true
                }
            }).then(function(result){
                $scope.dateformats = result.data.dateformats;
            });
        };


        $scope.submit = function(){

            $http.put("/Users/edit/" + $scope.id + ".json", $scope.post).then(function(result){
                var url = $state.href('UsersEdit', {id: result.data.user.id});
                NotyService.genericSuccess({
                    message: '<u><a href="' + url + '" class="txt-color-white"> '
                        + $scope.successMessage.objectName
                        + '</a></u> ' + $scope.successMessage.message
                });
                $state.go('UsersIndex');
            }, function errorCallback(result){
                if(result.data.hasOwnProperty('validationErrors')){
                    $scope.errors = result.data.validationErrors;
                }
            });

        };

        //Fire on page load
        $scope.loadUsergroups();
        $scope.loadDateformats();
        $scope.load();
    });
