angular.module('openITCOCKPIT').directive('serviceStatusDetailsModal', function($http, $state, $interval, NotyService){
    return {
        restrict: 'E',
        templateUrl: '/services/servicestatusdetailsmodal.html',

        controller: function($scope){

            $scope.modalHostname = '';
            $scope.servicedetails = false;

            $scope.showFlashMsg = function(){
                new Noty({
                    theme: 'metroui',
                    type: 'success',
                    layout: 'topCenter',
                    text: $scope.flashMshStr,
                    timeout: 4000
                }).show();

                $scope.showFlashSuccess = true;
                $scope.autoRefreshCounter = 5;
                var interval = $interval(function(){
                    $scope.autoRefreshCounter--;
                    if($scope.autoRefreshCounter === 0){
                        $scope.load();
                        $interval.cancel(interval);
                        $scope.showFlashSuccess = false;
                    }
                }, 1000);
            };

            $scope.loadServiceDetails = function(servicestatus){
                $scope.modalHostname = servicestatus.hostname;
                $http.get("/services/browser.json", {
                    params: {
                        'serviceuuid': servicestatus.service_description
                    }
                }).then(function(result){
                    $('#angularServiceStatusDetailsModal').modal('show');
                    $scope.servicestatus = result.data.servicestatus;
                    $scope.acknowledgement = result.data.acknowledgement;
                    $scope.downtime = result.data.downtime;

                });
            };

            $scope.getObjectsForDowntimeDelete = function(){
                return [{
                    Host: {
                        uuid: $scope.servicestatus.hostname
                    },
                    Service: {
                        uuid: $scope.servicestatus.service_description
                    },
                    Downtime: {
                        internal_downtime_id: $scope.downtime.internal_downtime_id
                    }
                }];
            };

            $scope.goToServiceDetails = function(){
                $('#angularServiceStatusDetailsModal').modal('hide');
                $('#angularServiceStatusDetailsModal').on('hidden.bs.modal', function(){
                    $state.go('servicedetails', {
                        hostuuid: $scope.servicedetails.hostname,
                        serviceuuid: $scope.servicedetails.service_description
                    });
                });
            };

            $scope.stateIsOk = function(){
                return parseInt($scope.servicestatus.current_state, 10) === 0;
            };

            $scope.stateIsWarning = function(){
                return parseInt($scope.servicestatus.current_state, 10) === 1;
            };

            $scope.stateIsCritical = function(){
                return parseInt($scope.servicestatus.current_state, 10) === 2;
            };

            $scope.stateIsUnknown = function(){
                return parseInt($scope.servicestatus.current_state, 10) === 3;
            };
        },

        link: function($scope, element, attr){
            $scope.showServiceDetails = function(servicestatus){
                $scope.loadServiceDetails(servicestatus);
            }
        }
    };
});
