angular.module('openITCOCKPIT').directive('servicestatusicon', function($interval){
    return {
        restrict: 'E',
        templateUrl: '/services/icon.html',
        scope: {
            'state': '=?',
            'isFlapping': '=?'
        },
        controller: function($scope){

            if(typeof $scope.state === "undefined"){
                //Fake Servicestatus
                $scope.state = -1;
            }

            if(typeof $scope.isFlapping === "undefined"){
                $scope.isFlapping = 0;
            }

            $scope.flappingState = false;
            var interval;

            $scope.setServiceStatusColors = function(){
                var current_state = parseInt($scope.state, 10);

                switch(current_state){
                    case 0:
                        $scope.btnColor = 'success';
                        $scope.flappingColor = 'txt-color-green';
                        return;
                    case 1:
                        $scope.btnColor = 'warning';
                        $scope.flappingColor = 'warning';
                        return;
                    case 2:
                        $scope.btnColor = 'danger';
                        $scope.flappingColor = 'txt-color-red';
                        return;
                    case 3:
                        $scope.btnColor = 'secondary';
                        $scope.flappingColor = 'txt-color-blueDark';
                        return;
                    default:
                        $scope.btnColor = 'primary';
                        $scope.flappingColor = 'text-primary';
                }
            };

            $scope.startFlapping = function(){
                $scope.stopFlapping();
                interval = $interval(function(){
                    if($scope.flappingState === 0){
                        $scope.flappingState = 1;
                    }else{
                        $scope.flappingState = 0;
                    }
                }, 750);
            };

            $scope.stopFlapping = function(){
                if(interval){
                    $interval.cancel(interval);
                }
                interval = null;
            };

            $scope.setServiceStatusColors();
            if($scope.isFlapping){
                $scope.startFlapping();
            }else{
                $scope.stopFlapping();
            }
        },

        link: function(scope, element, attr){

        }
    };
});
