<?php
// Copyright (C) <2018>  <it-novum GmbH>
//
// This file is dual licensed
//
// 1.
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation, version 3 of the License.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
// 2.
//  If you purchased an openITCOCKPIT Enterprise Edition you can use this file
//  under the terms of the openITCOCKPIT Enterprise Edition license agreement.
//  License agreement and license key will be shipped with the order
//  confirmation.

namespace itnovum\openITCOCKPIT\Checks\Receiver\ValueObjects;

class PerfdataGauge {

    /**
     * @var string
     */
    private $label = '';

    /**
     * @var float
     */
    private $value;

    /**
     * @var string
     */
    private $unit = '';

    /**
     * @var null|float
     */
    private $warning;

    /**
     * @var null|float
     */
    private $critical;

    /**
     * @var null|float
     */
    private $min;

    /**
     * @var null|float
     */
    private $max;

    /**
     * PerfdataGauge constructor.
     * @param string $label
     * @param float|int $value
     * @param string $unit
     * @param null|float $warning
     * @param null|float $critical
     * @param null|float $min
     * @param null|float $max
     */
    public function __construct($label, $value = 0, $unit = '', $warning = null, $critical = null, $min = null, $max = null) {
        $this->label = $label;
        $this->value = $value;
        $this->unit = $unit;
        $this->warning = $warning;
        $this->critical = $critical;
        $this->min = $min;
        $this->max = $max;
    }

    /**
     * @return string
     */
    public function getLabel() {
        return $this->label;
    }

    /**
     * @return float
     */
    public function getValue() {
        return $this->value;
    }

    /**
     * @return string
     */
    public function getUnit() {
        return $this->unit;
    }

    /**
     * @return float|null
     */
    public function getWarning() {
        return $this->warning;
    }

    /**
     * @return float|null
     */
    public function getCritical() {
        return $this->critical;
    }

    /**
     * @return float|null
     */
    public function getMin() {
        return $this->min;
    }

    /**
     * @return float|null
     */
    public function getMax() {
        return $this->max;
    }

}